<html>
<head>
<title>Binary to Hex conversion</title>
</head>
<body bgcolor="beige" onload = "setfocus('AnsId')">
<div align=center>
<h1>Binary to Hexadecimal Conversion Quest</h1>
<?php

global $bin;

startCheck();
printBinary();
getAns();

function startCheck()
        { 
	   $myAns = "";
	   if (array_key_exists('myAns', $_POST))
	      {
	         $myAns = $_POST['myAns'];
	      }
	   if (array_key_exists('binVal', $_POST))
	      {
	         $bin = $_POST['binVal'];
 	      }

           if (!isset($myAns) | $myAns == "")
              {
                 print "<h2>Figure out the hexadecimal for these binary numbers!</h2>";
              }
           else
              {
 		 $realAns = calcAns($bin);
                 if ($myAns == $realAns)
                    {
                       print "<h3>Yes - You Got It!</h3>";
                    }
                 else
                    {
                       print "<h3>Maybe next time!</h3>";
                    }  
              }
          }


function printBinary()
        {
	   global $bin;
	   $bin = genBinVals();

           $cards = rand(2,4);
	   switch($cards)
		{
		   case 2:
                     twoCards();
        	     break;
		   case 3:
                     threeCards();
        	     break;
		   case 4:
                     fourCards();
        	     break;
	         }

	}

function genBinVals()
	{
  	   $binStr = '0000';
           $onesVal = rand(0,1);
	   $binStr[3] = (string)$onesVal;
           $twosVal = rand(0,1);
	   $binStr[2] = (string)$twosVal;
           $foursVal = rand(0,1);
	   $binStr[1] = (string)$foursVal;
           $eightsVal = rand(0,1);
	   $bin[0] = (string)$eightsVal;
	   return $binStr;
	}

function twoCards()

       {
	   global $bin;

	   $bin[0] = '0';
	   $bin[1] = '0';         
           showBinary($bin[2]);
           showBinary($bin[3]);
	}

function threeCards()
       {
           global $bin;

	   $bin[0] = '0';
           showBinary($bin[1]);
           showBinary($bin[2]);
           showBinary($bin[3]);
	}


function fourCards()
       {
           global $bin;

           showBinary($bin[0]);
           showBinary($bin[1]);
           showBinary($bin[2]);
           showBinary($bin[3]);

	}

function showBinary($which)
        {
         print <<<HERE
           <img src = "binary$which.PNG"
                height = 100 width = 100>
HERE;
	}

function calcAns($bin)
	{
	   $hexArr = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
	   $decAns = ($bin[0] * 8) + ($bin[1] * 4) + ($bin[2] * 2) + ($bin[3] * 1);
	   $hexAns = $hexArr[$decAns];
	   return $hexAns;
	}


function getAns()
	{
 	   global $bin;
	   print <<<HERE
	      <h3>Convert the binary to hexadecimal:</h3>
 	      <form method = "post" >
	      <input type = "text" name = "myAns" id = "AnsId" value = "" >
	      <input type = "hidden" name ="binVal" value = "$bin">
 	      <br><br><br><br>
 	      <input type = "submit" value = "Submit Answer" >

	      <script type='text/javascript'>
			function setfocus(elementID)
			   {
			      document.getElementById(elementID).focus();
			   }
	      </script>

 	      </form>
HERE;
	}
?>
</div>
</body>

</html>
